> For the complete documentation index, see [llms.txt](https://docs.wisej.com/ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.wisej.com/ai/components/api/services/irerankingservice.md).

# IRerankingService

Namespace: **Wisej.AI.Services**

Assembly: **Wisej.AI** (3.5.0.0)

Represents a service for reranking documents based on a given query.

{% tabs %}
{% tab title="C#" %}

```csharp
public interface IRerankingService
```

{% endtab %}

{% tab title="VB.NET" %}

```visual-basic
Public Interface IRerankingService
```

{% endtab %}
{% endtabs %}

## Properties

### ![](/files/ptrKjmmRoQB76pvrIqh0) TopN

[Int32](https://docs.microsoft.com/dotnet/api/system.int32): Gets or sets the maximum number of documents to return in the reranked response. If set to 0 it will return all the documents in the input.

## Methods

### ![](/files/ptrKjmmRoQB76pvrIqh0) RerankAsync(query, chunks)

Asynchronously reranks the provided chunks based on the specified query.

| Parameter  | Type                                                              | Description                              |
| ---------- | ----------------------------------------------------------------- | ---------------------------------------- |
| **query**  | [String](https://docs.microsoft.com/dotnet/api/system.string)     | The query used to rerank the chunks.     |
| **chunks** | [String\[\]](https://docs.microsoft.com/dotnet/api/system.string) | The array of text inputs to be reranked. |

**Returns:** [Task\<String\[\]>](https://docs.microsoft.com/dotnet/api/system.threading.tasks.task-1). A task that represents the asynchronous operation. The task result contains an array of reranked text inputs.

## Implemented By

| Name                                                                                                                  | Description                                                                                                                                                                                                                                                     |
| --------------------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| [DefaultRerankingService](/ai/components/api/services/irerankingservice/wisej.ai.services.defaultrerankingservice.md) | Provides a default implementation of the [IRerankingService](/ai/components/api/services/irerankingservice.md) for reranking documents using a specified endpoint to an AI provider. It uses LLM models to rerank and optionally optimize the submitted inputs. |
| [LocalAIRerankingService](https://docs.wisej.com/api?q=wisej.ai.services.localairerankingservice)                     | Represents a service for reranking text inputs using the LocalAI API.                                                                                                                                                                                           |
| [PineconeRerankingService](https://docs.wisej.com/api?q=wisej.ai.services.pineconererankingservice)                   | Represents a service for reranking text inputs using the Pinecone API.                                                                                                                                                                                          |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.wisej.com/ai/components/api/services/irerankingservice.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
